import es
import random
import popuplib
import cmdlib
import soccer.soccer as soccerlib
import urllib
import playerlib
import time
import nativetools
import services
from cPickle import dump
from gamethread import delayed
from os import path

info = es.AddonInfo()
info.name = "Soccer Ref Script"
info.version = soccerlib.info.version
info.basename = "soccerautoref"
info.author = "chrismrulz"

soccergoalie_enabled = int(soccerlib.config["Core"]["soccergoalie_enabled"])
teams = soccerlib.config["Ref"]["teams"]
soccerlib.refvars['ctteam'] = soccerlib.config["Ref"]["ctteam"]
soccerlib.refvars['tteam'] = soccerlib.config["Ref"]["tteam"]
periodlength = time.strptime(soccerlib.config["Ref"]["periodlength"], "%H:%M:%S")
periodlength = int(time.strftime('%H', periodlength)) * 3600 + int(time.strftime('%M', periodlength)) * 60 + int(time.strftime('%S', periodlength))
breaklength = time.strptime(soccerlib.config["Ref"]["breaklength"], "%H:%M:%S")
breaklength = int(time.strftime('%H', breaklength)) * 3600 + int(time.strftime('%M', breaklength)) * 60 + int(time.strftime('%S', breaklength))
lo3length = time.strptime(soccerlib.config["Ref"]["lo3length"], "%H:%M:%S")
lo3length = int(time.strftime('%H', lo3length)) * 3600 + int(time.strftime('%M', lo3length)) * 60 + int(time.strftime('%S', lo3length))
periods = int(soccerlib.config["Ref"]["periods"])
period_autoend = int(soccerlib.config["Ref"]["period_autoend"])
deathgoals = int(soccerlib.config["Ref"]["deathgoals"])
periodfreeze = int(soccerlib.config["Ref"]["periodfreeze"])
refmsgs = int(soccerlib.config["Ref"]["refmsgs"])
pen_autogoalie = int(soccerlib.config["Ref"]["pen_autogoalie"])
pen_newround = int(soccerlib.config["Ref"]["pen_newround"])
autoupdateaddress = soccerlib.config["Stats"]["autoupdateaddress"]
autoupdatepassword = soccerlib.config["Stats"]["autoupdatepassword"]
goalhp = soccerlib.goalhp
goaldisty = soccerlib.goaldisty
pbx = soccerlib.pbx
pbz = soccerlib.pbz
pbcty = soccerlib.pbcty
pbty = soccerlib.pbty
ballname = soccerlib.ballname
reffile = es.getAddonPath('soccer') + '/refvars.cpickle'

def rmchosen(userid, choice, popupname):
	if(choice == 'ctplus'):
		ctscoreboard()
		soccerlib.refvars['ctscore'] += 1
		ctscoreboard()
		set_team_score(3, soccerlib.refvars['ctscore'])
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'ctminus'):
		ctscoreboard()
		soccerlib.refvars['ctscore'] -= 1
		ctscoreboard()
		set_team_score(3, soccerlib.refvars['ctscore'])
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'tplus'):
		tscoreboard()
		soccerlib.refvars['tscore'] += 1
		tscoreboard()
		set_team_score(2, soccerlib.refvars['tscore'])
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'tminus'):
		tscoreboard()
		soccerlib.refvars['tscore'] -= 1
		tscoreboard()
		set_team_score(2, soccerlib.refvars['tscore'])
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'endperiod'):
		ep()
	elif(choice == 'startkickoff'):
		rp = random.choice(playerlib.getUseridList('#alive'))
		soccerlib.dofire(rp, 'func_physbox', 'addoutput \"ondamaged point_servercommand,command,es_xdoblock soccer/soccerautoref/finishpen\"')
		soccerlib.dofire(rp, ballname, 'enablemotion')
		soccerlib.dofire(rp, ballname, 'sleep')
		soccerlib.refvars['pen_kickoff'] = 1
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'pause'):
		if(soccerlib.refvars['doingbreak'] == 0):
			if(soccerlib.refvars['ptime_live'] == 1):
				pauseptime()
			else:
				unpauseptime()
		elif(soccerlib.refvars['doingbreak'] == 1):
			if(soccerlib.refvars['btime_live'] == 1):
				pausebtime()
			else:
				unpausebtime()
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'slaymenu'):
		popuplib.close(popupname, userid)
		slaychosen(userid)
	elif(choice == 'setteams'):
		if(teams != 0):
			popuplib.close(popupname, userid)
			setteamschosen(userid)
	elif(choice == 'refresh'):
		if(refmsgs != 2):
			popuplib.close(popupname, userid)
			if(popupname == 'refmenu'):
				refmenushow()
			else:
				updatemenuscores(popupname)
			delayed(1, popuplib.send, (popupname, userid))
	elif(choice == 'periodstart'):
		if(soccerlib.refvars['doingbreak'] == 0):
			if(soccerlib.refvars['ptime_live'] == 1):
				soccerlib.refvars['ptime_time'] = 0
			else:
				resetchosen()
				endperiod()
				if(teams != 0):
					delayed(8, setteamschosen, (userid))
		elif(soccerlib.refvars['doingbreak'] == 1):
			if(soccerlib.refvars['btime_live'] == 1):
				soccerlib.refvars['btime_time'] = 0
	elif(choice == 'plusperiodtime'):
		if(soccerlib.refvars['doingbreak'] == 0):
			soccerlib.refvars['ptime_time'] += 60
		elif(soccerlib.refvars['doingbreak'] == 1):
			soccerlib.refvars['btime_time'] += 60
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'minusperiodtime'):
		if(soccerlib.refvars['doingbreak'] == 0):
			soccerlib.refvars['ptime_time'] -= 60
		elif(soccerlib.refvars['doingbreak'] == 1):
			soccerlib.refvars['btime_time'] -= 60
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'plusperiod'):
		periodscoreboard()
		soccerlib.refvars['period'] += 1
		periodscoreboard()
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'minusperiod'):
		periodscoreboard()
		soccerlib.refvars['period'] -= 1
		periodscoreboard()
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'stopperiod'):
		if(soccerlib.refvars['doingbreak'] == 0):
			if(soccerlib.refvars['ptime_live'] == 1):
				stopptime()
			else:
				startptime()
		elif(soccerlib.refvars['doingbreak'] == 1):
			if(soccerlib.refvars['btime_live'] == 1):
				stopbtime()
			else:
				startbtime()
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'reset'):
		resetchosen()
		if(refmsgs != 2):
			updatemenus(popupname)
	elif(choice == 'penaltymenu'):
		soccerlib.refvars['pen_keeper'] = 0
		soccerlib.refvars['pen_taker'] = 0
		soccerlib.refvars['pen_okeeper'] = 0
		soccerlib.refvars['pen_teamid'] = 0
		penaltychosen(userid)
	elif(choice == 'cancelpenalty'):
		soccerlib.refvars['pen_kickoff'] = 1
		finishpen()
		es.server.cmd('mp_restartgame 1')
	elif(choice == 'refmenu'):
		popuplib.close(popupname, userid)
		refmenushow()
		delayed(1, popuplib.send, ('refmenu', userid))

popups = {}
popups['refmenu'] = popuplib.easymenu('refmenu', None, rmchosen)
popups['refmenu'].addoption('ctplus', 'CT Score +')
popups['refmenu'].addoption('ctminus', 'CT Score -')
popups['refmenu'].addoption('tplus', 'T Score +')
popups['refmenu'].addoption('tminus', 'T Score -')
popups['refmenu'].addoption('pause', 'Pause Break')
popups['refmenu'].addoption('slaymenu', 'Slay Player')
popups['refmenu'].addoption('setteams', 'Set Teams')
popups['refmenu'].addoption('refresh', 'Refresh')
popups['refmenu'].addoption('periodstart', 'Start Match')
popups['refmenu'].addoption('plusperiodtime', '+ 1 Minute Period Time')
popups['refmenu'].addoption('minusperiodtime', '- 1 Minute Period Time')
popups['refmenu'].addoption('plusperiod', '+ 1 Period Number')
popups['refmenu'].addoption('minusperiod', '- 1 Period Number')
popups['refmenu'].addoption('stopperiod', 'Stop Period')
popups['refmenu'].addoption('reset', 'Reset All')
popups['refmenu'].addoption('penaltymenu', 'Penalty')

popups['pumenu'] = popuplib.easymenu('pumenu', None, rmchosen)
popups['pumenu'].setdescription('Period Finished!!')
popups['pumenu'].addoption('ctplus', 'CT Score +')
popups['pumenu'].addoption('ctminus', 'CT Score -')
popups['pumenu'].addoption('tplus', 'T Score +')
popups['pumenu'].addoption('tminus', 'T Score -')
popups['pumenu'].addoption('endperiod', 'End Period')
popups['pumenu'].addoption('refmenu', 'Show Full Menu')
popups['pumenu'].addoption('slaymenu', 'Slay Player')
popups['pumenu'].addoption('penaltymenu', 'Penalty')

popups['pmenu'] = popuplib.easymenu('pmenu', None, rmchosen)
popups['pmenu'].setdescription('Penalty Mode')
popups['pmenu'].addoption('ctplus', 'CT Score +')
popups['pmenu'].addoption('ctminus', 'CT Score -')
popups['pmenu'].addoption('tplus', 'T Score +')
popups['pmenu'].addoption('tminus', 'T Score -')
popups['pmenu'].addoption('startkickoff', 'Start Kickoff')
popups['pmenu'].addoption('cancelpenalty', 'Cancel Penalty')
popups['pmenu'].addoption('slaymenu', 'Slay Player')

def load():
	es.msg("#Green", "Soccer Auto-Ref Script On - by Toph")
	setup_auth()
	loadblock()

def unload():
	cmdlib.unregisterClientCommand('ref')
	cmdlib.unregisterSayCommand('!ref')
	cmdlib.unregisterClientCommand('setteams')
	cmdlib.unregisterSayCommand('!setteams')
	cmdlib.unregisterClientCommand('score')
	cmdlib.unregisterSayCommand('!score')
	es.msg("#Green", "Soccer Auto-Ref Script Off")

def es_map_start(event_var):
	loadblock()

def loadblock():
	if(es.exists('saycommand', '!ref') != 1):
		cmdlib.registerSayCommand('!ref', ref, 'Shows the ref menu', 'use_ref', 'ADMIN')
	if(es.exists('clientcommand', 'ref') != 1):
		cmdlib.registerClientCommand('ref', ref, 'Shows the ref menu', 'use_ref', 'ADMIN')
	if(es.exists('saycommand', '!setteams') != 1):
		cmdlib.registerSayCommand('!setteams', setteams, 'Shows the ref menu', 'use_setteams', 'ADMIN')
	if(es.exists('clientcommand', 'setteams') != 1):
		cmdlib.registerClientCommand('setteams', setteams, 'Shows the ref menu', 'use_setteams', 'ADMIN')
	if(es.exists('saycommand', '!score') != 1):
		cmdlib.registerSayCommand('!score', showscorecmd, 'Shows the scores')
	if(es.exists('clientcommand', 'score') != 1):
		cmdlib.registerClientCommand('score', showscorecmd, 'Shows the scores')
	if(path.exists(reffile)):
		from cPickle import load
		readref = open(reffile, 'r')
		soccerlib.refvars = load(readref)
		readref.close()
		if(soccerlib.refvars['doingbreak'] == 0):
			pauseptime()
		elif(soccerlib.refvars['doingbreak'] == 1):
			pausebtime()
	else:
		prepref()
	doptime()
	dobtime()

def doptime():
	soccerlib.refvars['ptime_time'] -= 1
	if(soccerlib.refvars['ptime_time'] > 0):
		timescoreboard()
	if(soccerlib.refvars['ptime_live'] == 1):
		delayed(1, doptime)
		checkptime()

def dobtime():
	soccerlib.refvars['btime_time'] -= 1
	if(soccerlib.refvars['btime_live'] == 1):
		delayed(1, dobtime)
		checkbtime()

def saveref():
	saverefdb()
	if(autoupdateaddress != ""):
		urllib.urlopen('%s?password=%s' % (autoupdateaddress, autoupdatepassword))

def saverefdb():
	writerefvars = open(reffile, 'w')
	dump(soccerlib.refvars, writerefvars)
	writerefvars.close()

def round_end(event_var):
	saveref()

def server_shutdown(event_var):
	saveref()

def prepref():
	soccerlib.refvars['ptime_live'] = 0
	soccerlib.refvars['ptime_time'] = 0
	soccerlib.refvars['btime_live'] = 0
	soccerlib.refvars['btime_time'] = 0
	soccerlib.refvars['tscore'] = 0
	soccerlib.refvars['ctscore'] = 0
	soccerlib.refvars['period'] = 0
	soccerlib.refvars['perup'] = 0
	soccerlib.refvars['doingbreak'] = 0
	soccerlib.refvars['pen_live'] = 0
	soccerlib.refvars['pen_kickoff'] = 0
	soccerlib.refvars['pen_keeper'] = 0
	soccerlib.refvars['pen_taker'] = 0
	soccerlib.refvars['pen_okeeper'] = 0
	soccerlib.refvars['pen_teamid'] = 0

def set_team_score(team, score):
	for index in es.createentitylist('cs_team_manager'):
		if(es.getindexprop(index, 'CTeam.m_iTeamNum')) == team:
			es.setindexprop(index, 'CTeam.m_iScore', score)

def player_hurt(event_var):
	if(event_var['weapon'] != 'knife'):
		if(int(event_var['dmg_health']) == goalhp and soccerlib.roundfinished == 0):
			goalscored(int(event_var['es_userteam']))
		elif(deathgoals == 1 and int(event_var['dmg_health']) > goalhp and donedeadround == 0 and soccerlib.roundfinished == 1):
			global donedeadround
			donedeadround = 1
			goalscored(int(event_var['es_userteam']))

def goalscored(team):
	if(soccerlib.refvars['doingbreak'] == 0):
		if(soccerlib.refvars['ptime_live'] == 1):
			if(team == 2):
				soccerlib.refvars['ctscore'] += 1
			if(team == 3):
				soccerlib.refvars['tscore'] += 1
			if(refmsgs != 2):
				if(soccerlib.refvars['perup'] == 0):
					updatemenus('refmenu')
				else:
					updatemenus('pumenu')

def oldteamscoreboard():
	oldteams = teams.split(",")
	soccerlib.dofire(random.choice(playerlib.getUseridList('#alive')), "t%s_left" % str(oldteams.index(soccerlib.refvars['ctteam']) + 1), 'toggle')
	soccerlib.dofire(random.choice(playerlib.getUseridList('#alive')), "t%s_right" % str(oldteams.index(soccerlib.refvars['tteam']) + 1), 'toggle')

def teamscoreboard():
	mapname = es.getString('host_map')
	if('ka_soccer_20' in mapname):
		if('2008_v5' in mapname):
			oldteamscoreboard()
		elif('2009_beta1' in mapname):
			oldteamscoreboard()
		else:
			rp = random.choice(playerlib.getUseridList('#alive'))
			doscoreboardteams(rp, soccerlib.refvars['ctteam'], 'left')
			doscoreboardteams(rp, soccerlib.refvars['tteam'], 'right')

def doscoreboardteams(rp, team, side):
	spaces = float(len(team)) / 2
	if(side == 'left'):
		spaces = 6 - spaces
		if(".5" in str(spaces)):
			spaces -= 1
		team = int(round(spaces)) * ' ' + team
	if(side == 'right'):
		spaces = 5 - spaces
		if(".5" in str(spaces)):
			spaces -= 1
		team = int(round(spaces)) * ' ' + team
	i = 0
	for part in list(team):
		i += 1
		soccerlib.dofire(rp, 't%s%s_%s' % (i, part, side), 'toggle')

def removelast(rp):
	if(yleft != -1):
		soccerlib.dofire(rp, 'yleft_0%s' % yleft, 'toggle')
	if(yright != -1):
		soccerlib.dofire(rp, 'yright_0%s' % yright, 'toggle')
	if(y2left != -1):
		soccerlib.dofire(rp, 'y2left_0%s' % y2left, 'toggle')
	if(y2right != -1):
		soccerlib.dofire(rp, 'y2right_0%s' % y2right, 'toggle')

def round_start(event_var):
	global tsbused
	tsbused = False
	set_team_score(2, soccerlib.refvars['tscore'])
	set_team_score(3, soccerlib.refvars['ctscore'])
	ctscoreboard()
	tscoreboard()
	teamscoreboard()
	periodscoreboard()
	if(soccerlib.refvars['pen_live'] == 1):
		penlive()
	if(deathgoals == 1):
		global donedeadround
		donedeadround = 0

def startbtime():
	soccerlib.refvars['btime_live'] = 1
	soccerlib.refvars['btime_time'] = breaklength
	dobtime()

def stopbtime():
	soccerlib.refvars['btime_live'] = 0
	soccerlib.refvars['btime_time'] = breaklength

def pausebtime():
	soccerlib.refvars['btime_live'] = 0

def unpausebtime():
	soccerlib.refvars['btime_time'] += 1
	soccerlib.refvars['btime_live'] = 1
	dobtime()

def editteams():
	global ectteam
	global etteam
	if(soccerlib.refvars['ctteam'] == ""):
		ectteam = "Counter-Terrorists"
	else:
		ectteam = soccerlib.refvars['ctteam'].replace("_", " ")
	if(soccerlib.refvars['tteam'] == ""):
		etteam = "Terrorists"
	else:
		etteam = soccerlib.refvars['tteam'].replace("_", " ")

def dispscores():
	editteams()
	return '%s: %s | %s: %s' % (ectteam, soccerlib.refvars['ctscore'], etteam, soccerlib.refvars['tscore'])

def dispdetails():
	if(soccerlib.refvars['doingbreak'] == 1):
			if(soccerlib.refvars['btime_time'] >= 3600):
				newbtime = time.strftime('%H:%M:%S Hours', time.gmtime(soccerlib.refvars['btime_time']))
			elif(soccerlib.refvars['btime_time'] >= 60):
				newbtime = time.strftime('%M:%S Minutes', time.gmtime(soccerlib.refvars['btime_time']))
			elif(soccerlib.refvars['btime_time'] > 0):
				newbtime = time.strftime('%S Seconds', time.gmtime(soccerlib.refvars['btime_time']))
			else:
				return 'Period break not started yet.'
			return '%s remaining until period %s starts' % (newbtime, soccerlib.refvars['period'])
	else:
			if(soccerlib.refvars['ptime_time'] >= 3600):
				newptime = time.strftime('%H:%M:%S Hours', time.gmtime(soccerlib.refvars['ptime_time']))
			elif(soccerlib.refvars['ptime_time'] >= 60):
				newptime = time.strftime('%M:%S Minutes', time.gmtime(soccerlib.refvars['ptime_time']))
			elif(soccerlib.refvars['ptime_time'] > 0):
				newptime = time.strftime('%S Seconds', time.gmtime(soccerlib.refvars['ptime_time']))
			else:
				return 'Period not started yet.'
			return '%s remaining in period %s' % (newptime, soccerlib.refvars['period'])

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('ref', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isIdAuthorized(x, 'ref')
    else:
        isAuthed = lambda x: False

def updatemenuscores(popup):
	global popups
	popups[popup].settitle(dispscores())
	popups[popup].setoption('ctplus', '%s Score +' % ectteam)
	popups[popup].setoption('ctminus', '%s Score -' % ectteam)
	popups[popup].setoption('tplus', '%s Score +' % etteam)
	popups[popup].setoption('tminus', '%s Score -' % etteam)

def updatemenus(popupname):
	if(popupname == 'refmenu'):
		refmenushow()
	else:
		updatemenuscores(popupname)
	if(refmsgs == 1):
		playerlist = playerlib.getPlayerList('#all')
	else:
		playerlist = playerlib.getPlayerList('#spec,#un')
	for player in playerlist:
		if(isAuthed(player.steamid)):
			for p in popups:
				popuplib.close(p, player.userid)
			delayed(1, popuplib.send, (popupname, player.userid))

def freezeall(on, slay=0):
	for player in playerlib.getPlayerList('#alive'):
		player.freeze(on)
		if(slay == 1):
			delayed(1.5, soccerlib.slay, player)

def timescoreboard():
	rp = random.choice(playerlib.getUseridList('#alive'))
	if(tsbused):
		removelast(rp)
	newptime = time.gmtime(soccerlib.refvars['ptime_time'])
	secs = time.strftime('%S', newptime)
	mins = time.strftime('%M', newptime)
	global yleft
	global yright
	global y2left
	global y2right
	yleft = mins[0:1]
	yright = mins[1:2]
	y2left = secs[0:1]
	y2right = secs[1:2]
	soccerlib.dofire(rp, 'yleft_0%s' % yleft, 'toggle')
	soccerlib.dofire(rp, 'yright_0%s' % yright, 'toggle')
	soccerlib.dofire(rp, 'y2left_0%s' % y2left, 'toggle')
	soccerlib.dofire(rp, 'y2right_0%s' % y2right, 'toggle')
	global tsbused
	tsbused = True

def periodscoreboard():
	if(soccerlib.refvars['period'] < 10):
		rp = random.choice(playerlib.getUseridList('#alive'))
		soccerlib.dofire(rp, 'periodleft_0%s' % soccerlib.refvars['period'], 'toggle')

def ctscoreboard():
	rp = random.choice(playerlib.getUseridList('#alive'))
	if(soccerlib.refvars['ctscore'] < 10):
		soccerlib.dofire(rp, 'gleft_00', 'toggle')
		soccerlib.dofire(rp, 'gright_0%s' % soccerlib.refvars['ctscore'], 'toggle')
	else:
		soccerlib.dofire(rp, 'gleft_0%s' % str(soccerlib.refvars['ctscore'])[0:1], 'toggle')
		soccerlib.dofire(rp, 'gright_0%s' % str(soccerlib.refvars['ctscore'])[1:2], 'toggle')

def tscoreboard():
	rp = random.choice(playerlib.getUseridList('#alive'))
	if(soccerlib.refvars['tscore'] < 10):
		soccerlib.dofire(rp, 'rleft_00', 'toggle')
		soccerlib.dofire(rp, 'rright_0%s' % soccerlib.refvars['tscore'], 'toggle')
	else:
		soccerlib.dofire(rp, 'rleft_0%s' % str(soccerlib.refvars['tscore'])[0:1], 'toggle')
		soccerlib.dofire(rp, 'rright_0%s' % str(soccerlib.refvars['tscore'])[1:2], 'toggle')

def ref(userid, args):	
	if(soccerlib.refvars['pen_live'] == 1):
		updatemenuscores('pmenu')
		popuplib.send('pmenu', userid)
	elif(soccerlib.refvars['perup'] == 0):
		refmenushow()
		popuplib.send('refmenu', userid)
	else:
		updatemenuscores('pumenu')
		popuplib.send('pumenu', userid)

def player_spawn(event_var):
	if(soccerlib.refvars['doingbreak'] == 1 and soccerlib.refvars['pen_live'] == 0 and periodfreeze == 1):
		playerlib.getPlayer(event_var['userid']).freeze(1)

def periodfinishedep():
	es.msg('#lightgreen', dispscores())
	endperiod()
	soccerlib.refvars['perup'] = 0
	popuplib.close('pmenu', es.getUseridList())

def endperiod():
	soccerlib.refvars['doingbreak'] = 1
	soccerlib.refvars['period'] += 1
	stopptime()
	freezeall(1, 1)
	delayed(8, startbtime)

def checkptime():
	if(soccerlib.refvars['ptime_time'] <= 0):
		if(period_autoend == 1):
			ep()
		else:
			stopptime()
			soccerlib.refvars['perup'] = 1
			popuplib.close('refmenu', es.getUseridList())
			if(refmsgs != 2):
				updatemenus('pumenu')

def startptime():
	es.server.cmd('exec lo3')
	soccerlib.refvars['ptime_live'] = 1
	soccerlib.refvars['ptime_time'] = periodlength
	delayed(lo3length, doptime)

def stopptime():
	soccerlib.refvars['ptime_live'] = 0
	soccerlib.refvars['ptime_time'] = periodlength

def pauseptime():
	soccerlib.refvars['ptime_live'] = 0

def unpauseptime():
	soccerlib.refvars['ptime_live'] = 1
	soccerlib.refvars['ptime_time'] += 1
	doptime()

def checkbtime():
	if(soccerlib.refvars['btime_time'] <= breaklength):
		if(soccerlib.refvars['btime_time'] > 0):
			es.centermsg(dispdetails())
		else:
			soccerlib.refvars['doingbreak'] = 0
			stopbtime()
			es.centermsg('Period %s starting..' % soccerlib.refvars['period'])
			if(refmsgs != 2):
				updatemenus('refmenu')
			delayed(1, startptime)

def refmenushow():
	global popups
	popups['refmenu'].setdescription(dispdetails())
	updatemenuscores('refmenu')
	if(soccerlib.refvars['doingbreak'] == 1):
		if(soccerlib.refvars['btime_live'] == 1):
			popups['refmenu'].setoption('pause', 'Pause Break')
		else:
			popups['refmenu'].setoption('pause', 'Resume Break')
	elif(soccerlib.refvars['ptime_live'] == 1):
		popups['refmenu'].setoption('pause', 'Pause Period')
	else:
		popups['refmenu'].setoption('pause', 'Resume Period')
	if(soccerlib.refvars['doingbreak'] == 1):
		if(soccerlib.refvars['btime_live'] == 1):
			popups['refmenu'].setoption('periodstart', 'End Break Early')
		popups['refmenu'].setoption('plusperiodtime', '+ 1 Minute Break Time')
		popups['refmenu'].setoption('minusperiodtime', '- 1 Minute Break Time')
	else:
		if(soccerlib.refvars['ptime_live'] == 1):
			popups['refmenu'].setoption('periodstart', 'End Period Early')
		else:
			popups['refmenu'].setoption('periodstart', 'Start Match')
		popups['refmenu'].setoption('plusperiodtime', '+ 1 Minute Period Time')
		popups['refmenu'].setoption('minusperiodtime', '- 1 Minute Period Time')
	if(soccerlib.refvars['doingbreak'] == 1):
		if(soccerlib.refvars['btime_live'] == 1):
			popups['refmenu'].setoption('stopperiod', 'Stop Break')
		else:
			popups['refmenu'].setoption('stopperiod', 'Start Break')
	else:
		if(soccerlib.refvars['ptime_live'] == 1):
			popups['refmenu'].setoption('stopperiod', 'Stop Period')
		else:
			popups['refmenu'].setoption('stopperiod', 'Start Period')
	popups['refmenu'].setoption('reset', 'Reset All')

def showscorecmd(userid, args):
	es.msg('#lightgreen', dispscores())
	es.msg('#lightgreen', dispdetails())

def setteams(userid, args):
	if(len(args) > 1):
		teamscoreboard()
		soccerlib.refvars['ctteam'] = args[0]
		soccerlib.refvars['tteam'] = args[1]
		teamscoreboard()
		es.tell(userid, '#lightgreen', 'Teams successfully set.')

def setteamschosen(userid):
	popuplib.close('refmenu', userid)
	teamsmenu()
	delayed(1, popuplib.send, ('teamspicked', userid))
	es.tell(userid, '#green', 'Select the counter-terrorist team.')

def teamsmenu():
	teamscoreboard()
	soccerlib.refvars['ctteam'] = ""
	soccerlib.refvars['tteam'] = ""
	teamspicked = popuplib.easymenu('teamspicked', None, teamchosen)
	teamspicked.settitle('Teams')
	for team in teams:
		teamspicked.addoption(team.replace("_", " "), team.replace("_", " "))

def teamchosen(userid, choice, popupname):
	if(soccerlib.refvars['ctteam'] == ""):
		es.tell(userid, '#green', 'Counter-terrorist team set. Select the terrorist team.')
		soccerlib.refvars['ctteam'] = choice
		teamscoreboard()
		popuplib.close('teamspicked', userid)
		delayed(1, popuplib.send, ('teamspicked', userid))
	else:
		es.tell(userid, '#green', 'Teams successfully set.')
		teamscoreboard()
		soccerlib.refvars['tteam'] = choice
		teamscoreboard()
		popuplib.close('teamspicked', userid)
		menuback(userid)

def ep():
	if(soccerlib.refvars['period'] == periods):
		if(soccerlib.refvars['tscore'] == soccerlib.refvars['ctscore']):
			global periods
			periods += 1
			periodfinishedep()
			es.msg('#lightgreen', 'Scores are tied. An extra round of overtime will be played.')
		else:
			es.msg('#lightgreen', 'Match finished.')
			es.msg('#lightgreen', dispscores())
			resetchosen()
			freezeall(1, 1)
	else:
		es.msg('#lightgreen', 'Period %s finished.' % soccerlib.refvars['period'])
		periodfinishedep()
	if(refmsgs != 2):
		updatemenus('refmenu')

def resetchosen():
	ctscoreboard()
	tscoreboard()
	teamscoreboard()
	prepref()
	set_team_score(2, soccerlib.refvars['tscore'])
	set_team_score(3, soccerlib.refvars['ctscore'])
	ctscoreboard()
	tscoreboard()
	teamscoreboard()

def slaychosen(userid):
	global popups
	popups['slaymenu'] = popuplib.construct('slaymenu', 'players', '#all', slayhandler)
	popups['slaymenu'].settitle('Select a player to slay.')
	popuplib.send('slaymenu', userid)

def slayhandler(userid, choice, popupname):
	soccerlib.slay(choice)
	es.msg('#multi', '#greenPlayer#lightgreen %s #greenslayed by referee#lightgreen %s' % (es.getplayername(choice), es.getplayername(userid)))
	menuback(userid)

def penaltychosen(userid):
	global popups
	if(soccerlib.refvars['pen_taker'] == 0):
		popups['penaltymenu'] = popuplib.construct('penaltymenu', 'players', '#all', penaltymenuchosen)
		popups['penaltymenu'].settitle('Select a player to take the penalty kick.')
	else:
		if(soccerlib.refvars['pen_teamid'] == 2):
			pen_fteamid = "#ct"
		elif(soccerlib.refvars['pen_teamid'] == 3):
			pen_fteamid = "#t"
		popups['penaltymenu'] = popuplib.construct('penaltymenu', 'players', pen_fteamid, penaltymenuchosen)
		popups['penaltymenu'].settitle('Select a player to goalkeep.')
	popuplib.send('penaltymenu', userid)

def penaltymenuchosen(userid, choice, popupname):
	if(soccerlib.refvars['pen_taker'] == 0):
		soccerlib.refvars['pen_taker'] = choice
		soccerlib.refvars['pen_teamid'] = es.getplayerteam(soccerlib.refvars['pen_taker'])
		if(soccergoalie_enabled == 0 or pen_autogoalie == 0):
			penaltychosen(userid)
		else:
			if(soccergoalie_enabled == 1):
				if(soccerlib.refvars['pen_teamid'] == 2):
					soccerlib.refvars['pen_keeper'] = es.getInt('thectgoalie')
					if(es.getInt('thetgoalie') != soccerlib.refvars['pen_taker']):
						soccerlib.refvars['pen_okeeper'] = es.getInt('thetgoalie')
				else:
					soccerlib.refvars['pen_keeper'] = es.getInt('thetgoalie')
					if(es.getInt('thectgoalie') != soccerlib.refvars['pen_taker']):
						soccerlib.refvars['pen_okeeper'] = es.getInt('thectgoalie')
			elif(soccergoalie_enabled == 2):
				if(soccerlib.refvars['pen_teamid'] == 2):
					soccerlib.refvars['pen_keeper'] = es.getuserid(es.getString('ctgoalie'))
					soccerlib.refvars['pen_okeeper'] = es.getuserid(es.getString('tgoalie'))
				else:
					soccerlib.refvars['pen_keeper'] = es.getuserid(es.getString('tgoalie'))
					soccerlib.refvars['pen_okeeper'] = es.getuserid(es.getString('ctgoalie'))
				if(soccerlib.refvars['pen_okeeper'] == soccerlib.refvars['pen_taker']):
					soccerlib.refvars['pen_okeeper'] = 0
			if(soccerlib.refvars['pen_keeper'] < 1):
				penaltychosen(userid)
			else:
				penaltyfinished(userid)
	else:
		soccerlib.refvars['pen_keeper'] = choice
		penaltyfinished(userid)

def penaltyfinished(userid):
	if(soccerlib.refvars['doingbreak'] == 0):
		pauseptime()
	elif(soccerlib.refvars['doingbreak'] == 1):
		pausebtime()
	soccerlib.refvars['pen_live'] = 1
	es.msg('#multi', '#greenReferee#lightgreen %s #greenhas called a penalty.' % es.getplayername(userid))
	es.msg('#multi', '#greenPlayer#lightgreen %s #greenwill take the shot. Player#lightgreen %s #greenwill be the goalie.' % (es.getplayername(soccerlib.refvars['pen_taker']), es.getplayername(soccerlib.refvars['pen_keeper'])))
	menuback(userid)
	if(pen_newround == 1):
		es.server.cmd('mp_restartgame 1')
	else:
		penlive()
	nativetools.movementRegister(soccerlib.refvars['pen_taker'], impulse_performed, buttons_changed, False)
	updatemenuscores('pmenu')
	delayed(1, popuplib.send, ('pmenu', userid))

def finishpen():
	if(soccerlib.refvars['pen_kickoff'] == 1):
		nativetools.movementUnregister(soccerlib.refvars['pen_taker'], impulse_performed, buttons_changed)
		soccerlib.refvars['pen_live'] = 0
		soccerlib.refvars['pen_kickoff'] = 0
		soccerlib.refvars['pen_keeper'] = 0
		soccerlib.refvars['pen_taker'] = 0
		soccerlib.refvars['pen_okeeper'] = 0
		soccerlib.refvars['pen_teamid'] = 0
		freezeall(0)
		popuplib.close('pmenu', es.getUseridList())
		if(soccerlib.refvars['doingbreak'] == 0):
			if(soccerlib.refvars['ptime_time'] > 0):
				unpauseptime()
			updatemenus('refmenu')
		elif(soccerlib.refvars['doingbreak'] == 1):
			if(soccerlib.refvars['btime_time'] > 0):
				unpausebtime()
			updatemenus('pumenu')

def impulse_performed(userid, impulse):
	return 0

def buttons_changed(userid, buttons):
	if buttons & nativetools.BTN_DUCK:
		buttons &= ~nativetools.BTN_DUCK
	return buttons

def penlive():
	rp = random.choice(playerlib.getUseridList('#alive'))
	soccerlib.dofire(rp, ballname, 'disablemotion')
	if(soccerlib.refvars['pen_teamid'] == 2):
		soccerlib.dofire(rp, ballname, 'addoutput \"origin %s %s %s\"' % (pbx, pbty, pbz))
	else:
		soccerlib.dofire(rp, ballname, 'addoutput \"origin %s %s %s\"' % (pbx, pbcty, pbz))
	pensetplayers()

def pensetplayers():
	pmap = es.getlivingplayercount()
	if(soccerlib.refvars['pen_okeeper'] == 0):
		pmap -= 2
	else:
		pmap -= 3
	pmap = int(pmap / 2)
	py = pyside()
	py2,py3 = py,py
	if(soccerlib.refvars['pen_teamid'] == 2):
		if(pbcty < pbty):
			py2 += goaldisty
			py3 -= goaldisty
		else:
			py2 -= goaldisty
			py3 += goaldisty
	else:
		if(pbcty < pbty):
			py2 -= goaldisty
			py3 += goaldisty
		else:
			py2 += goaldisty
			py3 -= goaldisty
	playerlib.getPlayer(soccerlib.refvars['pen_keeper']).setLocation([pbx, py2, pbz])
	playerlib.getPlayer(soccerlib.refvars['pen_taker']).setLocation([pbx, py3, pbz])
	if(soccerlib.refvars['pen_okeeper'] != 0):
		playerlib.getPlayer(soccerlib.refvars['pen_okeeper']).setLocation([pbx, pysideo(), pbz])
		playerlib.getPlayer(soccerlib.refvars['pen_okeeper']).freeze(1)
	global pmindex
	pmindex = 0
	for player in playerlib.getPlayerList('#alive'):
		penplayer(player, pmap, pmap + 1, py)

def penplayer(player, pmap, pmap2, py):
	if(player.userid != soccerlib.refvars['pen_okeeper'] and player.userid != soccerlib.refvars['pen_keeper'] and player.userid != soccerlib.refvars['pen_taker']):
		player.freeze(1)
		global pmindex
		pmindex += 1
		if(pmindex <= pmap):
			if(pmindex > 1):
				player.setLocation([pbx - 700, changepy(py), pbz])
		elif(pmindex == pmap2):
			player.setLocation([pbx + 700, py, pbz])
		else:
			player.setLocation([pbx + 700, changepy(py), pbz])

def pyside():
	if(soccerlib.refvars['pen_teamid'] == 2):
		return pbty
	else:
		return pbcty

def pysideo():
	if(soccerlib.refvars['pen_teamid'] == 2):
		return pbcty
	else:
		return pbty

def changepy(py):
	if(pbcty < pbty):
		if(soccerlib.refvars['pen_teamid'] == 2):
			return py - 100
		else:
			return py + 100
	elif(soccerlib.refvars['pen_teamid'] == 2):
		return py + 100
	else:
		return py - 100

def menuback(userid):
	if(soccerlib.refvars['perup'] == 1):
		updatemenuscores('pumenu')
		delayed(1, popuplib.send, ('pumenu', userid))
	else:
		refmenushow()
		delayed(1, popuplib.send, ('refmenu', userid))